#ifndef ACTOR_HPP
#define ACTOR_HPP

#include <map>
#include <memory>
#include "Movie.hpp"

class Actor {
   public:
      Actor(const std::string& name) : name(name) {
      }
      const std::string& get_name() const {
	 return name;
      }
      void add_movie(MoviePtr movie) {
	 movies.insert(std::make_pair(movie->get_title(), movie));
      }
      MoviePtr lookup(const std::string& title) {
	 auto it = movies.find(title);
	 if (it == movies.end()) return nullptr;
	 return it->second;
      }

   private:
      const std::string name;
      std::map<std::string, MoviePtr> movies;
};

using ActorPtr = std::shared_ptr<Actor>;

#endif
