#include <fstream>
#include <iostream>
#include <sstream>
#include "Database.hpp"

bool Database::read_database(const std::string& infile) {
   std::size_t count_movies = 0;
   std::size_t count_actors = 0;
   std::size_t count = 0;
   std::ifstream in(infile);
   if (!in) return false;
   std::string line;
   while (std::getline(in, line)) {
      std::istringstream is(line);
      std::string title;
      if (std::getline(is, title, '~')) {
	 MoviePtr movie = std::make_shared<Movie>(title); ++count_movies;
	 movies.insert(std::make_pair(title, movie));
	 std::string name;
	 while (std::getline(is, name, '~')) {
	    ActorPtr actor = lookup_actor(name);
	    if (!actor) {
	       actor = std::make_shared<Actor>(name); ++count_actors;
	       actors.insert(std::make_pair(name, actor));
	    }
	    actor->add_movie(movie);
	 }
      }
      if (++count % 100 == 0) {
	 std::cout << count_movies << "/" << count_actors << "\r";
      }
   }
   std::cout << actors.size() << " actors and " <<
      movies.size() << " movies loaded." << std::endl;
   return true;
}
