#ifndef DATABASE_HPP
#define DATABASE_HPP

#include "Actor.hpp"
#include "Movie.hpp"
#include <map>
#include <string>

class Database {
   public:
      bool read_database(const std::string& infile);
      ActorPtr lookup_actor(const std::string& name) const {
	 auto it = actors.find(name);
	 if (it == actors.end()) return nullptr;
	 return it->second;
      }
      MoviePtr lookup_movie(const std::string& title) const {
	 auto it = movies.find(title);
	 if (it == movies.end()) return nullptr;
	 return it->second;
      }
      std::size_t number_of_actors() const {
	 return actors.size();
      }
      std::size_t number_of_movies() const {
	 return movies.size();
      }
   private:
      std::map<std::string, ActorPtr> actors;
      std::map<std::string, MoviePtr> movies;
};


#endif
